Subject: Re: RFC: Flat directory for notes, or fan-out? Both!

From: Sam Vilain <[email-masked]>
Date: Wed, 11 Feb 2009 14:14:38 +1300

Johannes Schindelin wrote:
> Hi,
>
> Shawn triggered some well needed thinking on my part about the notes 
> implementation.  At the moment, we have flat directory structure, and read 
> all of them in one go (when needed).
>
> I think we should support that, because it is relatively easy to generate 
> that kind of trees for small-scale applications.
>
> However, I think there is also a benefit to handle fan-out directory 
> structures, too: they scale much nicer.
>
> If the commit name was not found as a filename, it could be searched in 
> whatever subdirectory whose name is a prefix of said commit name (first 
> wins).
>   

Great idea! Glad I thought of it! ;-)

http://thread.gmane.org/gmane.comp.version-control.git/106715/focus=107975

I hoped my approach allowed for smarter things later, such as splitting
into smaller buckets whenever a directory gets more than N entries or
periodically rebalancing if required. But the initial version is at
least forward thinking to support reading it.

Merging them will need to be savvy of this of course.

Sam.